package model;

import java.util.ArrayList;

public class Bishop extends Piece {

    public Bishop(Position p, int color) {
        super(p, color);
    }


    public ArrayList<Position> getAvailableMoves(Board b) {

        // creates a dynamic list of available moves
        ArrayList<Position> moves = new ArrayList<Position>();

        Position arrival;

        Position Cursor = new Position(p.getX(), p.getY());

        int i = 1;
        boolean leftTop = false;
        boolean rightTop = false;
        boolean leftDown = false;
        boolean rightDown = false;

        while (i < 8) {

            //left diagonal

            arrival = new Position(p.getX() + i, p.getY() + i);

            if (!leftTop) {
                if (b.isEnnemy(arrival, p) || b.isFree(arrival)) {
                    moves.add(arrival);
                }
            }

            if (!b.isFree(arrival)) {
                leftTop = true;
            }





            //right diagonal
            arrival = new Position(p.getX() - i, p.getY() + i);
            if (!rightTop) {
                if (b.isEnnemy(arrival, p) || b.isFree(arrival)) {
                    moves.add(arrival);
                }
            }
            if (!b.isFree(arrival)) {
                rightTop = true;
            }



            arrival = new Position(p.getX() + i, p.getY() - i);
            if (!leftDown) {
                if (b.isEnnemy(arrival, p) || b.isFree(arrival)) {
                    moves.add(arrival);
                }
            }
            if (!b.isFree(arrival)) {
                leftDown = true;
            }



            arrival = new Position(p.getX() - i, p.getY() - i);
            if (!rightDown) {
                if (b.isEnnemy(arrival, p) || b.isFree(arrival)) {
                    moves.add(arrival);
                }
            }
            if (!b.isFree(arrival)) {
                rightDown = true;
            }


            i++;
        }


        return moves;
    }
}
