package model;

import java.util.ArrayList;


public class King extends Piece {

	private boolean Casteling = true;
	private final Position original;

	public King(Position p, int color) {
		super(p, color);
		this.original = p;
	}


	public ArrayList<Position> getAvailableMoves(Board b) {

		// creates a dynamic list of available moves
		ArrayList<Position> moves = new ArrayList<Position>();

		Position arrival;

		// up
		arrival = new Position(p.getX(), p.getY() + 1);
		if(b.isEnnemy(arrival,p) || b.isFree(arrival)) { moves.add(arrival); }

		//down
		arrival = new Position(p.getX(), p.getY() - 1);
		if(b.isEnnemy(arrival,p) || b.isFree(arrival)) { moves.add(arrival); }

		//left
		arrival = new Position(p.getX()+1, p.getY());
		if(b.isEnnemy(arrival,p) || b.isFree(arrival)) { moves.add(arrival); }

		//right
		arrival = new Position(p.getX()-1, p.getY());
		if(b.isEnnemy(arrival,p) || b.isFree(arrival)) { moves.add(arrival); }

		//up left
		arrival = new Position(p.getX()-1, p.getY() + 1);
		if(b.isEnnemy(arrival,p) || b.isFree(arrival)) { moves.add(arrival); }

		//up right
		arrival = new Position(p.getX()+1, p.getY() + 1);
		if(b.isEnnemy(arrival,p) || b.isFree(arrival)) { moves.add(arrival); }

		//down left
		arrival = new Position(p.getX()-1, p.getY() -1);
		if(b.isEnnemy(arrival,p) || b.isFree(arrival)) { moves.add(arrival); }

		//down right
		arrival = new Position(p.getX()+1, p.getY() - 1);
		if(b.isEnnemy(arrival,p) || b.isFree(arrival)) { moves.add(arrival); }

		arrival = new Position(p.getX(), p.getY() + 1);
		if(b.isEnnemy(arrival,p) || b.isFree(arrival)) { moves.add(arrival); }



		return moves;
	}
}

