package model;

import java.util.ArrayList;

public class Knight extends Piece {


    public Knight(Position p, int color) {
        super(p, color);
    }


    public ArrayList<Position> getAvailableMoves(Board b) {

        // creates a dynamic list of available moves
        ArrayList<Position> moves = new ArrayList<Position>();

        Position arrival;


        arrival = new Position(p.getX() - 1, p.getY() + 2);
        if (b.isEnnemy(arrival, p) || b.isFree(arrival)) {
            moves.add(arrival);
        }

        // up right
        arrival = new Position(p.getX() + 1, p.getY() + 2);
        if (b.isEnnemy(arrival, p) || b.isFree(arrival)) {
            moves.add(arrival);
        }

        // down left
        arrival = new Position(p.getX() - 1, p.getY() - 2);
        if (b.isEnnemy(arrival, p) || b.isFree(arrival)) {
            moves.add(arrival);
        }

        //down right
        arrival = new Position(p.getX() + 1, p.getY() - 2);
        if (b.isEnnemy(arrival, p) || b.isFree(arrival)) {
            moves.add(arrival);
        }

        arrival = new Position(p.getX() - 2, p.getY() + 1);
        if (b.isEnnemy(arrival, p) || b.isFree(arrival)) {
            moves.add(arrival);
        }

        // up right
        arrival = new Position(p.getX() + 2, p.getY() + 1);
        if (b.isEnnemy(arrival, p) || b.isFree(arrival)) {
            moves.add(arrival);
        }
        // down left
        arrival = new Position(p.getX() - 2, p.getY() - 1);
        if (b.isEnnemy(arrival, p) || b.isFree(arrival)) {
            moves.add(arrival);
        }

        //down right
        arrival = new Position(p.getX() + 2, p.getY() - 1);
        if (b.isEnnemy(arrival, p) || b.isFree(arrival)) {
            moves.add(arrival);
        }

        return moves;
    }
}
