package model;

import java.util.ArrayList;

public class Pawn extends Piece {
	private final Position original;
	public Pawn(Position p, int color) {
		super(p, color);
		this.original = p;
	}


	public ArrayList<Position> getAvailableMoves(Board b) {

		// creates a dynamic list of available moves
		ArrayList<Position> moves = new ArrayList<Position>();

		Position arrival;
		if(color == Piece.WHITE) { // black and white have an opposite direction behavior

			if(this.p.getID() == this.original.getID()){
			//	up, free movement first time
						arrival = new Position(p.getX(), p.getY() + 2);
				if(Position.isCorrect(arrival) && b.isFree(arrival)) { moves.add(arrival); }

			}

			// up, free movement
			arrival = new Position(p.getX(), p.getY() + 1);
			if(Position.isCorrect(arrival) && b.isFree(arrival)) { moves.add(arrival); }

			// up right, attack movement
			arrival = new Position(p.getX() + 1, p.getY() + 1);
			if(Position.isCorrect(arrival) && b.isBlack(arrival)) { moves.add(arrival); }

			// up left, attack movement
			arrival = new Position(p.getX() - 1, p.getY() + 1);
			if(Position.isCorrect(arrival) && b.isBlack(arrival)) { moves.add(arrival); }

		}
		else {

			if(this.p.getID() == this.original.getID()){
				//	up, free movement first time
				arrival = new Position(p.getX(), p.getY() - 2);
				if(Position.isCorrect(arrival) && b.isFree(arrival)) { moves.add(arrival); }
			}

			// down, free movement
			arrival = new Position(p.getX(), p.getY() - 1);
			if(Position.isCorrect(arrival) && b.isFree(arrival)) { moves.add(arrival); }

			// down right, attack movement
			arrival = new Position(p.getX() + 1, p.getY() - 1);
			if(Position.isCorrect(arrival) && b.isWhite(arrival)) { moves.add(arrival); }

			// down left, attack movement
			arrival = new Position(p.getX() - 1, p.getY() - 1);
			if(Position.isCorrect(arrival) && b.isWhite(arrival)) { moves.add(arrival); }

		}
		return moves;
	}
}

