package model;

import java.util.ArrayList;

public class Queen extends Piece{
    protected Queen(Position p, int color) {
        super(p, color);
    }


    public ArrayList<Position> getAvailableMoves(Board b) {

        // creates a dynamic list of available moves
        ArrayList<Position> moves = new ArrayList<Position>();

        Position arrival;


        int i = 1;
        boolean left = false;
        boolean right = false;
        boolean top = false;
        boolean down = false;
        boolean leftTop = false;
        boolean rightTop = false;
        boolean leftDown = false;
        boolean rightDown = false;

        while (i < 8) {
            // Bishop moves
            arrival = new Position(p.getX() + i, p.getY() + i);

            if (!leftTop) {
                if (b.isEnnemy(arrival, p) || b.isFree(arrival)) {
                    moves.add(arrival);
                }
            }

            if (!b.isFree(arrival)) {
                leftTop = true;
            }





            //right diagonal
            arrival = new Position(p.getX() - i, p.getY() + i);
            if (!rightTop) {
                if (b.isEnnemy(arrival, p) || b.isFree(arrival)) {
                    moves.add(arrival);
                }
            }
            if (!b.isFree(arrival)) {
                rightTop = true;
            }



            arrival = new Position(p.getX() + i, p.getY() - i);
            if (!leftDown) {
                if (b.isEnnemy(arrival, p) || b.isFree(arrival)) {
                    moves.add(arrival);
                }
            }
            if (!b.isFree(arrival)) {
                leftDown = true;
            }



            arrival = new Position(p.getX() - i, p.getY() - i);
            if (!rightDown) {
                if (b.isEnnemy(arrival, p) || b.isFree(arrival)) {
                    moves.add(arrival);
                }
            }
            if (!b.isFree(arrival)) {
                rightDown = true;
            }


            // RooK moves

            arrival = new Position(p.getX() +i, p.getY());

            if (!left) {
                if (b.isEnnemy(arrival, p) || b.isFree(arrival)) {
                    moves.add(arrival);
                }
            }

            if (!b.isFree(arrival)) {
                left = true;
            }



            //right diagonal
            arrival = new Position(p.getX()- i , p.getY() );
            if (!right) {
                if (b.isEnnemy(arrival, p) || b.isFree(arrival)) {
                    moves.add(arrival);
                }
            }
            if (!b.isFree(arrival)) {
                right = true;
            }



            arrival = new Position(p.getX(), p.getY() + i);
            if (!top) {
                if (b.isEnnemy(arrival, p) || b.isFree(arrival)) {
                    moves.add(arrival);
                }
            }
            if (!b.isFree(arrival)) {
                top = true;
            }



            arrival = new Position(p.getX(), p.getY() - i);
            if (!down) {
                if (b.isEnnemy(arrival, p) || b.isFree(arrival)) {
                    moves.add(arrival);
                }
            }
            if (!b.isFree(arrival)) {
                down = true;
            }


            i++;
        }

        return moves;
    }
}
