package model;

import java.util.ArrayList;

public class Rook extends Piece {


    private final Position original;

    public Rook(Position p, int color) {
        super(p, color);
        this.original = p;
    }


    public ArrayList<Position> getAvailableMoves(Board b) {

        // creates a dynamic list of available moves
        ArrayList<Position> moves = new ArrayList<Position>();

        Position arrival;

        int i = 1;
        boolean left = false;
        boolean right = false;
        boolean top = false;
        boolean down = false;


        while (i < 8) {

            //left

            arrival = new Position(p.getX() + i, p.getY());
            if (Position.isCorrect(arrival)) {
                if (!left) {
                    if (b.isEnnemy(arrival, p) || b.isFree(arrival)) {
                        moves.add(arrival);
                    }

                    if (b.isKing(arrival)) {
                        moves.add(arrival);

                    }
                }
                if (!b.isFree(arrival)) {
                    left = true;
                }
            }

            //right
            arrival = new Position(p.getX() - i, p.getY());
            if (Position.isCorrect(arrival)) {
                if (!right) {
                    if (b.isEnnemy(arrival, p) || b.isFree(arrival)) {
                        moves.add(arrival);
                    }
                    if (b.isKing(arrival)) {
                        moves.add(arrival);
                    }
                }

                if (!b.isFree(arrival)) {

                    right = true;
                }
            }


            arrival = new Position(p.getX(), p.getY() + i);
            if (Position.isCorrect(arrival)) {
                if (!top) {
                    if (b.isEnnemy(arrival, p)|| b.isFree(arrival)) {
                        moves.add(arrival);
                    }
                }

                if (!b.isFree(arrival)) {

                    top = true;
                }
            }


            arrival = new Position(p.getX(), p.getY() - i);
            if(Position.isCorrect(arrival)||b.isFree(arrival)) {
                if (!down) {
                    if (b.isEnnemy(arrival, p)) {
                        moves.add(arrival);
                    }
                }
                if (!b.isFree(arrival)) {

                    down = true;
                }
            }

            i++;
        }

        return moves;
    }
}
