package view;

import javafx.scene.AmbientLight;
import javafx.scene.Group;
import javafx.scene.PointLight;
import javafx.scene.SpotLight;
import javafx.scene.paint.Color;
import javafx.scene.transform.Translate;

public class CustomLight {
	AmbientLight ambient;
	PointLight[] light;
	SpotLight spot;
	public CustomLight() {
		ambient = new AmbientLight(Color.rgb(35, 35, 35));
		light = new PointLight[3];
		light[0] = new PointLight(Color.rgb(191, 174, 148));
		light[1] = new PointLight(Color.rgb(191, 174, 148));
		light[2] = new PointLight(Color.rgb(191, 174, 148));
		light[0].getTransforms().add(new Translate(-100, -50, 100));
		light[1].getTransforms().add(new Translate(0, -60, -100));
		light[2].getTransforms().add(new Translate(100, -50, 100));
		spot = new SpotLight(Color.rgb(255,0,0));
		spot.getTransforms().add(new Translate(0, -50, 0));
	}

	public void addAllToScene(Group group) {
		// PS : javaFX have max HARDCAP of 3 pointlight/spotlights, and 1 ambient
		group.getChildren().addAll(light[0], light[1], light[2], ambient);
	}
}
